/*
Some global stuff that's visible in all modules of the demos 3dspdemo and sphdemo.
// If the sphere file spawns a header file, some stuff in here should go in.
*/


/*
	Allegro's polygon3d lacks the folowing modes:
	POLYTYPE_ATEX_LIT_MASK
	POLYTYPE_PTEX_LIT_MASK
*/


/* Co-ordinate spaces */
#define VIEWSPACE 0			// Co-ords relative to camera.
#define SCREENSPACE 1		// Co-ords in screenspace (relative to the monitor and perspective-projected)
#define POLARVIEWSPACE 2	// Co-ords using polar co-ordinates relative to camera.
// WORLDSPACE		// Co-ords relative to world.
// POLARWORLDSPACE		// Co-ords using polar co-ordinates relative to world.


/* Sphere shading modes. */
// If the sphere file spawns a header file, these should go in.
#define SPHERESHADE_FLAT 		0	// No light shading
#define SPHERESHADE_ILIT		1	// Lit from light at infinity
#define SPHERESHADE_PLIT		2	// Lit from a point.
#define SPHERESHADE_MLIT		3	// Lit from multiple sources.
// MLIT and COL don't go together(?)

/* Sphere texturing modes */
// If the sphere file spawns a header file, these should go in.
#define SPHERETEXTURE_NOTEXTURE_COL					0	//	Uses palette
#define SPHERETEXTURE_NOTEXTURE_RGB					1	//	Uses RGB table
// All types below use RGB table for lighting.
// However, in sphere.c, so far, they use the COL method.
#define SPHERETEXTURE_TEX					2
#define SPHERETEXTURE_MTEX					3
#define SPHERETEXTURE_MASK_TEX				4
#define SPHERETEXTURE_MASK_MTEX				5
#define SPHERETEXTURE_ROTATED_TEX			6
#define SPHERETEXTURE_ROTATED_MTEX			7
#define SPHERETEXTURE_ROTATED_MASK_TEX		8
#define SPHERETEXTURE_ROTATED_MASK_MTEX		9
// If I'm doing perspective-correct spheres, do I need to do something to the texture, or do the position vectors for each pixel take care of it?

// This nomenclature may not be correct (Mercartor), and I cannot guarantee at this stage that future releases of this won't break your code.

/*
With PLIT, perhaps the light could decay after a while?

MLIT accepts a pointer to a datastructure that contains several lightsources (both point and infinite).

could be implemented by passing the function a union of
'struct LIGHTSOURCE' 'struct *LIGHTSOURCE' .If struct_lightsource said if it was an I source or a P source, I could combine 2 types, and also with the last mode, each arraymember could be I or P.

A lightsource could be:
typedef struct LIGHTSOURCE {
	VECTOR light_vector;	ILIT: Direction, PLIT: Position.
	float decay;	// PLIT: How much the light decays over a distance
	RGB Intensity;	// Intensity of each of the 3 colours.
} LIGHTSOURCE;

// Could I also have a simple lighting mode: Not accurate, but fast.
the colour is a function of the previous pixel's colour.
*/



#define true 1
#define false 0


struct Z_BUFFER;	// Needed for global function prototypes for the spheres.

typedef struct VECTOR {
	fixed x;
	fixed y;
	fixed z;
} VECTOR;


typedef struct VECTOR_f {
	float x;
	float y;
	float z;
} VECTOR_f;

void sphere(BITMAP *bmp, struct Z_BUFFER *zb, BITMAP *texture_bitmap, int shade_type, int tex_type, fixed x_middle, fixed y_middle, fixed z_middle, fixed radius, fixed tex_xoffset, fixed tex_yoffset, fixed tex_xsize, fixed tex_ysize, MATRIX *texture_rotation_matrix, fixed light_shade, fixed dark_shade, fixed x_light, fixed y_light, fixed z_light);

void sphere_f(BITMAP *bmp, struct Z_BUFFER *zb, BITMAP *texture_bitmap, int shade_type, int tex_type, float x_middle, float y_middle, float z_middle, float radius, float tex_xoffset, float tex_yoffset, float tex_xsize, float tex_ysize, MATRIX_f *texture_rotation_matrix, fixed light_shade, fixed dark_shade, float x_light, float y_light, float z_light);
// light_shade, dark_shade 	// FIX -> FLOAT
