/*
zbuf.h
Header file for zbuf.c
*/


/*
A fast way of filling memory with a 'long' value
Should I define this in a file that is given greater scope than zbuf.h, as this is quite a useful function.
*/
#define fill_meml(value, dest, numlwords) \
__asm__ __volatile__ ( \
  "cld;" \
  "rep;" \
  "stosl;" \
  : : "a" (value), "D" (dest), "c" (numlwords) \
  : "%ecx", "%edi" )



typedef struct Z_BUFFER {
	int w, h;		// Width and Height (Useful for clearing zbuffer and working out positions).
	// In the future, I could have an indication as to what type of Z-buffer it is (ie. 1/z, z, 32/16-bit, etc.)
	void *dat;		/* Memory for the Zbuffer */
	float *line[0];	/* Pointers to the start of each line (change to void later) */
} Z_BUFFER;


Z_BUFFER *create_zbuffer(int width, int height);
void destroy_zbuffer(Z_BUFFER *old_zbuffer);
void fill_zbuffer(Z_BUFFER *fill_zbuffer, float value);
void clear_zbuffer(Z_BUFFER *clear_zbuffer);
