/*
zpriteds.h

Header for zpriteds.c (additional datastructures for working with zprites)

C++ users may want to write a zprite class instead of using my zpriteds.[c|h] files
*/

typedef struct ZPRITE {
	int w, h;
	BITMAP *bitmap;
	Z_BUFFER *z_buffer;
} ZPRITE;


ZPRITE *create_zprite(int width, int height);
ZPRITE *create_zprite_clear(int width, int height);
ZPRITE *set_zprite_to_bitmap(BITMAP *existing_bitmap);
ZPRITE *set_zprite_to_bitmap_clear(BITMAP *existing_bitmap);
ZPRITE *set_zprite_to_zbuffer(Z_BUFFER *existing_zbuffer);
ZPRITE *set_zprite_to_zbuffer_clear(Z_BUFFER *existing_zbuffer);
ZPRITE *set_zprite_to_both(BITMAP *existing_bitmap, Z_BUFFER *existing_zbuffer);

void destroy_zsprite(ZPRITE *old_zprite);
void destroy_set_to_bitmap_zprite(ZPRITE *old_zprite);
void destroy_set_to_zbuffer_zprite(ZPRITE *old_zprite);
void destroy_set_to_both_zprite(ZPRITE *old_zprite);

void clear_zprite(ZPRITE *the_zprite);
